import java.util.LinkedList;

public class Utils {

 public static <a> List<a> reverse (List<a> xs) {
  return reverseAcc(xs, new NIL());
 }

 public static <a> List<a> reverseAcc (List<a> xs, List<a> ys) {
  if (xs instanceof NIL) {
    return ys; 
  } else {
    return reverseAcc(((CONS<a>)xs).tl, new CONS<a>(((CONS<a>)xs).hd,ys));
  }
 }

 public static <a> List<a> snoc (List<a> xs, a x) {
  if (xs instanceof NIL) {
    return new CONS<a>(x, new NIL());
  } else if (((CONS<a>)xs).tl instanceof NIL) {
    ((CONS<a>)xs).tl = new CONS<a>(x,new NIL());
    return xs;
  } else {
    List<a> zs = snoc(((CONS<a>)xs).tl,x);
    return xs; 
  }
 }

  public static <a> java.util.LinkedList<a> list2JList (List<a> xs) {
    java.util.LinkedList<a> res = new java.util.LinkedList<a>();
    while (!(xs instanceof NIL)) {
      res.addLast((a)((CONS)xs).hd);
      xs = (List<a>)((CONS)xs).tl;
    }
    return res;
  }
  public static <a> List<a> jlist2List (java.util.LinkedList<a> xs) {
    List<a> res = new NIL<a>();
    java.util.Iterator<a> it = xs.iterator();
    while (it.hasNext()) {
      res = new CONS<a>(it.next(),res);
    }
    return res.reverse();
  }

  public static <a> a head(LinkedList<a> xs) {
    if (xs==null || xs.size()==0) {
      System.out.println("Utils.head: empty list"); // ToDo: throw error
      return null;
    } else {
      return xs.getFirst();
    }
  }
  public static <a> LinkedList<a> tail(LinkedList<a> xs) {
    //System.out.println("++ Utils.tail: entered with list " + xs.toString());
    if (xs==null || xs.size()==0) {
      System.out.println("Utils.tail: empty list"); // ToDo: throw error
      return null;
    } else {
      LinkedList<a> ys = new LinkedList<a>();
      ys.addAll(xs);
      //System.out.println("++ Utils.tail: cloned list is " + ys.toString());
      ys.removeFirst();
      return ys;
    }
  }

  public static <a> LinkedList<a> cons(a x, LinkedList<a> xs) {
    LinkedList<a> ys = new LinkedList<a>();
    ys.addFirst(x);
    if (xs==null || xs.size()==0) {
      return ys;
    } else {
      ys.addAll(xs);
      return ys;
    }
  }
    
  public static String show_codeseq(java.util.LinkedList<Stm> xs){
    PPIntm pp_intm = new PPIntm();
    String str = "";
    java.util.Iterator<Stm> it = xs.iterator();
    while (it.hasNext()){
      str = str + "\n" + pp_intm.visit(it.next());
    }
    return str;
  }

  public static String spaces(int n) { return (n==0?"":" "+spaces(n-1)) ; }

}
